﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.SceneManagement;

public class PlanetMovement : MonoBehaviour {

	[SerializeField]
	int moveSpeed;

	[SerializeField]
	float rotateVelocity;

	[SerializeField]
	Transform planet;

	private Rigidbody2D rb;

	[SerializeField]
	float gravitationalpull;

	[SerializeField]
	float jumpForce;

	[SerializeField]
	int lightHp;

	[SerializeField]
	int darkHp;

	public bool canJump;
	public bool run;

	public int lightEnergyCount;
	public int darkEnergyCount;

	SpriteRenderer sprite;
	Animator anim;

	// Use this for initialization
	void Start () {

		sprite = GetComponent<SpriteRenderer>();
		anim = GetComponent<Animator>();
		rb = GetComponent<Rigidbody2D>();

		lightEnergyCount = 0;
		darkEnergyCount = 0;

		lightHp = 10;
		darkHp = 10;

	}

	void Update() {

		Vector2 difference = planet.transform.position - this.transform.position;
		rb.AddForce((difference).normalized * gravitationalpull);
		float angle = Mathf.Atan2(difference.x, difference.y);
		this.transform.rotation = Quaternion.AngleAxis(angle, transform.up);

	}
	
	// Update is called once per frame
	void FixedUpdate () {

		if(Input.GetKey(KeyCode.D)) {

			anim.SetBool("Run", true);
			planet.gameObject.transform.Rotate(new Vector3(0f, 0f, moveSpeed * Time.deltaTime)); 
			sprite.flipX = false;

		} else {

			anim.SetBool("Run", false);

		}

		if(Input.GetKey(KeyCode.A)) {

			anim.SetBool("Run", true);
			planet.gameObject.transform.Rotate(new Vector3(0f, 0f, -moveSpeed * Time.deltaTime)); 
			sprite.flipX = true;

		} else {

			anim.SetBool("Run", false);

		}

		if(Input.GetKeyDown(KeyCode.Space)) {

			anim.SetBool("Jump", true);
			//rb.AddForce(Vector2.up * jumpForce);
			//rb.velocity += jumpForce * Vector2.up;
			rb.AddForce(new Vector3(0, 10, 0), ForceMode2D.Impulse); 

		}

	}

	void OnCollisionStay2D (Collision2D other) {

		if(other.gameObject.tag == "ground") {

			anim.SetBool("Jump", false);
			//canJump = true;

		} else {

			canJump = false;

		}

	}

	void OnTriggerEnter2D(Collider2D other) {

		if(other.gameObject.tag == "darkenergy") {

			darkEnergyCount = darkEnergyCount + 1;
			darkHp = darkHp + 1;

		}

		if(other.gameObject.tag == "lightenergy") {

			lightEnergyCount = lightEnergyCount + 1;
			lightHp = lightHp + 1;

		}

		if(other.gameObject.tag == "enemy") {

			//SceneManager.LoadScene("stage1");
			darkHp = darkHp - 1;
			lightHp = lightHp - 1;

		}

		if(other.gameObject.tag == "teleport") {

			// vai para a tela de seleção de planetas ou para o próximo planeta

		}

	}

}
